# MyCMake https://gitlab.com/open-kappa/cpp/mycmake
# (c) Francesco Stefanni
# Distributed under the MIT License. See accompanying files COPYRIGHT.txt
# and LICENSE.txt or https://gitlab.com/open-kappa/cpp/mycmake for details.

#[=======================================================================[.rst:
FindMyCMakeGlobals
------------------

MyCMake global variables configuration.
This is an internal module, please prefer to nclude :cmake:module:`MyCMakeBase.`

The variables here contained can be overridden by command line, or into the
CMakeLists.txt before including *any* of MyCMake modules.

Result Variables
^^^^^^^^^^^^^^^^

This will define the following variables:

.. cmake:variable:: MyCMakeGlobals_FOUND

    True if the module and its dependencies has been conrrectly found.

.. cmake:variable:: MyCMakeGlobals_VERSION

    This module version

CTest related variables
^^^^^^^^^^^^^^^^^^^^^^^

.. cmake:variable:: MYCMAKE_CTEST_DEFAULT_BINARY_DIR

    Default directory for regression tests. Defaults to
    :cmake:variable:`CMAKE_BINARY_DIR`/mycmake_regression

.. cmake:variable:: MYCMAKE_CTEST_DEFAULT_LOG_FILE_NAME

    Default test log file name.. Defaults to "log.txt"

.. cmake:variable:: MYCMAKE_CTEST_DEFAULT_SOURCE_DIR

    The tests sources main dir. Defaults to
    :cmake:variable:`CMAKE_SOURCE_DIR`/tests


Default components
^^^^^^^^^^^^^^^^^^

.. cmake:variable:: MYCMAKE_DEFAULT_COMPONENT_DEV

    Default component for headers and development tools. Defaults to "dev"

.. cmake:variable:: MYCMAKE_DEFAULT_COMPONENT_DOC

    Default component for documentation. Defaults to "doc"

.. cmake:variable:: MYCMAKE_DEFAULT_COMPONENT_MAIN

    Default component for binaries and targets


Directories layout
^^^^^^^^^^^^^^^^^^

.. cmake:variable:: MYCMAKE_DEFAULT_BUILD_DIRECTORY

    Default source build dir. Defaults to "build"

.. cmake:variable:: MYCMAKE_DEFAULT_REPO_DIRECTORY

    Default source repo dir. Defaults to "repo"

.. cmake:variable:: MYCMAKE_DEFAULT_THIRD_PARTIES_DIRECTORY

    Default third-party dir name. Defaults to "third-parties"


MyCMake related variables
^^^^^^^^^^^^^^^^^^^^^^^^^

.. cmake:variable:: MYCMAKE_DOC_SOURCE_DIR

    Default doc source directory. Defaults to :cmake:variable:`CMAKE_SOURCE_DIR`/doc

.. cmake:variable:: MYCMAKE_SCRIPTS_DIR

    Stores MyCMake install dir, i.e. where these scripts are deployed.

.. cmake:variable:: MYCMAKE_SCRIPTS_EXTRA_DIR

    Stores the path to "extra" directory, which contains support scripts.
    Defaults to :cmake:variable:`MYCMAKE_SCRIPTS_DIR`/extra

.. cmake:variable:: MYCMAKE_VERSION

    Stores this MyCMake release version.


Naming conventions
^^^^^^^^^^^^^^^^^^

.. cmake:variable:: MYCMAKE_ADDITIONAL_FILES_TARGET

    Default target name for additional files.
    Defaults to "Additional_Files"

.. cmake:variable:: MYCMAKE_DOC_TARGET_NAME

    Default doc target name. Defaults to "doc" string

.. cmake:variable:: MYCMAKE_EXPORTFILE_SUFFIX

    Suffix for file generated by :cmake:module:`GenerateExportHeader` module.
    Defaults to "Export.h"

.. cmake:variable:: MYCMAKE_FAKE_TARGET_NAME

    Default fake target name. Defaults to "MYCMAKE_FAKE_TARGET" string

.. cmake:variable:: MYCMAKE_STATIC_SUFFIX

    Default static lib target suffix. Defaults to "_static"


Functions and macros
^^^^^^^^^^^^^^^^^^^^

- :cmake:command:`mycmake_try_option()`
- :cmake:command:`mycmake_try_set()`

#]=======================================================================]
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
include_guard(GLOBAL)

find_package(PackageHandleStandardArgs)

set(MyCMakeGlobals_VERSION "0.0.1.0")

find_package_handle_standard_args(
        MyCMakeGlobals
    FOUND_VAR
        MyCMakeGlobals_FOUND
    REQUIRED_VARS
        MyCMakeGlobals_VERSION
    VERSION_VAR
        MyCMakeGlobals_VERSION
)

#[=======================================================================[.rst:
.. cmake:command:: mycmake_try_option

    Sets given option if not already set.

    .. code-block:: cmake

        mycmake_try_option(<NAME> [ARGN] [MYCMAKE_ADVANCED])

    **WARNING**: to be used only in global scope.

    Parameters:

    * ``<NAME>``: The variable name
    * ``ARGN``: The standard :cmake:command:`option()` parameters
    * ``MYCMAKE_ADVANCED``: Whether to tag as advanced
#]=======================================================================]
function(mycmake_try_option NAME)
    cmake_parse_arguments(mycmake_try_option_options "MYCMAKE_ADVANCED" "" "" ${ARGN})
    if (NOT (DEFINED "${NAME}"))
        option(${NAME} ${mycmake_try_option_options_UNPARSED_ARGUMENTS})
    endif (NOT (DEFINED "${NAME}"))
    if (mycmake_try_option_options_MYCMAKE_ADVANCED)
        mark_as_advanced(${NAME})
    endif (mycmake_try_option_options_MYCMAKE_ADVANCED)
endfunction(mycmake_try_option)

#[=======================================================================[.rst:
.. cmake:command:: mycmake_try_set

    Sets given variable if not already set.

    .. code-block:: cmake

        mycmake_try_set(<NAME> [ARGN] [MYCMAKE_ADVANCED])

    **WARNING**: to be used only in global scope.

    Parameters:

    * ``<NAME>``: The variable name
    * ``ARGN``: The standard :cmake:command:`set()` parameters
    * ``MYCMAKE_ADVANCED``: Whether to tag as advanced
#]=======================================================================]
function(mycmake_try_set NAME)
    cmake_parse_arguments(mycmake_try_set_options "MYCMAKE_ADVANCED" "" "" ${ARGN})
    if (NOT (DEFINED ${NAME}))
        set(${NAME} ${mycmake_try_set_options_UNPARSED_ARGUMENTS})
        set(${NAME} ${${NAME}} PARENT_SCOPE)
    endif (NOT (DEFINED ${NAME}))
    if (mycmake_try_set_options_MYCMAKE_ADVANCED)
        mark_as_advanced(${NAME})
    endif (mycmake_try_set_options_MYCMAKE_ADVANCED)
endfunction(mycmake_try_set)

# CTest related variables
mycmake_try_set(MYCMAKE_CTEST_DEFAULT_BINARY_DIR "${CMAKE_BINARY_DIR}/mycmake_regression")
mycmake_try_set(MYCMAKE_CTEST_DEFAULT_LOG_FILE_NAME "log.txt")
mycmake_try_set(MYCMAKE_CTEST_DEFAULT_SOURCE_DIR "${CMAKE_SOURCE_DIR}/tests")

# Default components
mycmake_try_set(MYCMAKE_DEFAULT_COMPONENT_DEV "dev")
mycmake_try_set(MYCMAKE_DEFAULT_COMPONENT_DOC "doc")
mycmake_try_set(MYCMAKE_DEFAULT_COMPONENT_MAIN "main")

# Directories layout
mycmake_try_set(MYCMAKE_DEFAULT_BUILD_DIRECTORY "build")
mycmake_try_set(MYCMAKE_DEFAULT_REPO_DIRECTORY "repo")
mycmake_try_set(MYCMAKE_DEFAULT_THIRD_PARTIES_DIRECTORY "third-parties")

# MyCMake related variables
mycmake_try_set(MYCMAKE_DOC_SOURCE_DIR "${CMAKE_SOURCE_DIR}/doc")
mycmake_try_set(MYCMAKE_SCRIPTS_DIR "${CMAKE_CURRENT_LIST_DIR}")
mycmake_try_set(MYCMAKE_SCRIPTS_EXTRA_DIR "${MYCMAKE_SCRIPTS_DIR}/extra")
mycmake_try_set(MYCMAKE_VERSION ${MyCMakeGlobals_VERSION})

# Naming conventions
mycmake_try_set(MYCMAKE_ADDITIONAL_FILES_TARGET "Additional_Files")
mycmake_try_set(MYCMAKE_DOC_TARGET_NAME "doc")
mycmake_try_set(MYCMAKE_EXPORTFILE_SUFFIX "Export.h")
mycmake_try_set(MYCMAKE_FAKE_TARGET_NAME "MYCMAKE_FAKE_TARGET")
mycmake_try_set(MYCMAKE_STATIC_SUFFIX "_static")

# EOF
